// AlphaBitmap3 etc library for Delphi6- or C++Builder6-
// Copyright(C)'2000- buin2gou(buin2gou2@ybb.ne.jp)
//
//
//
// QlEɈpz[y[W
//
// http://www.ngy.1st.ne.jp/~kengo/
// http://www2s.biglobe.ne.jp/~aks-lab/
// http://hp.vector.co.jp/authors/VA012950/aa/
// http://homepage1.nifty.com/beny/
// 
// ρE]ڂ͂RɂǂB

unit ABitmapEtcs;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids,ABitmap,math;
type
  TRGBA=packed record
       r:Byte;
       g:Byte;
       b:Byte;
       a:Byte;
  end;
  TRGBAArray = array[0..8191] of TRGBA;
  PRGBAArray = ^TRGBAArray;
  
  //A`GCAXtHg`
  procedure SuperTextOut(ToBMP:TBitmap;X,Y:Integer;bFont:TFont;Msg:String);

  procedure StdTextOutFast(iNo,x,y:Integer;text:String;bFOnt:TFont;Col:TColor;Canvas:TCanvas);
  procedure StdTextOut(iNo,x,y:Integer;text:String;bFOnt:TFont;Col:TColor;ToBMP:TBitmap);

  //C[`
  procedure SuperTextOut_Layer(ToBMP:TBitmap;X,Y:Integer;bFont:TFont;Msg:String);
  procedure SuperTextOutFast_Layer(ToBMP:TBitmap;X,Y:Integer;bFont:TFont;Msg:String);

  procedure StdTextOut_Layer(iNo,x,y:Integer;text:String;bFOnt:TFont;Col:TColor;ToBMP:TBitmap);
  procedure StdTextOutFast_Layer(iNo,x,y:Integer;text:String;bFOnt:TFont;Col:TColor;ToBMP:TBitmap);

  //J[L[At@`l֕ϊ
  procedure MakeColorKeyMask32(x,y,w,h:Integer;BMP:TBitmap;Col:TColor);


implementation


//o[WSDœKɂă}XNȂłȂ葬IoOI
// 02/ 3/15 e[u쐬ō
// 02/11/12 xX{S{ɗƂĂRRB
// 03/01/05 RQrbgύẌʒuςāAxQ{AbviSWj
procedure SuperTextOut(ToBMP:TBitmap;X,Y:Integer;bFont:TFont;Msg:String);
var x2,y2,x3:Integer;//[vp
    Pr :Integer;//Zϒl
    BMP      :TBitmap;
    Size     :TSize;
    pABit    :array[0..1] of PByteArray;
    W,H      :Integer;//
    iA,iA2   :DWORD;
    k3,k4:Integer;//ɌvZĂ܂
    r,g,b    :byte;
    li    :LongInt;
    PBit3: PRGBAArray;
    rgba:TRGBA;
begin
   li:=ColorToRGB(bFont.Color);

   b:=(li and $000000FF);
   g:=(li and $0000FF00) shr 8;
   r:=(li and $00FF0000) shr 16;


 //NGCg
 BMP:=TBitmap.Create;
 try

  //ݒ
  BMP.Canvas.Font.Name:=bFOnt.Name;
  BMP.Canvas.Font.Size:=bFOnt.Size*2;
  BMP.Canvas.Font.Style:=bFont.Style;


  //TCY͏قɍ킹
  Size:=BMP.Canvas.TextExtent(Msg);

  //̐ݒ
  W:=(Size.cx div 2);
  H:=(Size.cy div 2);

  BMP.PixelFormat  := pf32Bit;
  //TCYm
  BMP.Width  :=W*2+1;
  BMP.Height :=H*2+1;



  //`
  BMP.Canvas.Brush.Style:=bsClear;
  BMP.Canvas.Font.Color :=clBlack;
  BMP.Canvas.TextOut(0,0,msg);


  k3:=1;

  //Ƃ̃NbsOvZ

  if x+w>ToBMP.Width then begin
     w:=ToBMP.Width-x;
  end;

  if y+h>ToBMP.Height then begin
     h:=ToBMP.Height-y;
  end;



  for y2:=0 to h-1 do begin

      //xC̎擾
      Pbit3:=ToBMP.ScanLine[y2+y];

      //Oɒuč

      //XLC擾OŎs
      pABit[0]:=BMP.ScanLine[k3];
      inc(k3);
      pABit[1]:=BMP.ScanLine[k3];
      inc(k3);


      //ɌvZ
      x3:=x;
      k4:=0;

      for x2:=0 to w-1 do begin

          //qfa̎擾

             //ǂݍ
             Pr:=0;

             inc(pr,PABit[0][k4]);
             inc(pr,PABit[0][k4+4]);
             inc(pr,PABit[1][k4]);
             inc(pr,PABit[1][k4+4]);


             //ϒlo
             //
             iA:=(pr shr 2)+1;
             iA2:=256-iA;

             rgba:=pBit3[x3];
             rgba.r:=(rgba.r*iA+r*iA2) shr 8;
             rgba.g:=(rgba.g*iA+g*iA2) shr 8;
             rgba.b:=(rgba.b*iA+b*iA2) shr 8;
             

             pBit3[x3]:=rgba;
             inc(x3);
             inc(k4,8);
      end;
  end;



  finally
    //
    BMP.Free;
  end;

end;




procedure StdTextOutFast(iNo,x,y:Integer;text:String;bFOnt:TFont;Col:TColor;Canvas:TCanvas);
var dFont:TFOnt;
    i,i2 :Integer;
begin

  dFont:=TFOnt.Create;
  try
   dFont.Assign(Canvas.Font);
   Canvas.Font.Assign(bFont);

   Canvas.Brush.Style:=bsClear;
   case iNo of
        0:begin
           Canvas.TextOut(x,y,text);
          end;
        1:begin
           //
           Canvas.Font.Color:=Col;
           Canvas.TextOut(x+1,y+1,text);
           Canvas.TextOut(x+1,y  ,text);
           Canvas.TextOut(x+1,y-1,text);
           Canvas.TextOut(x  ,y+1,text);
           Canvas.TextOut(x  ,y-1,text);
           Canvas.TextOut(x-1,y+1,text);
           Canvas.TextOut(x-1,y  ,text);
           Canvas.TextOut(x-1,y-1,text);
           Canvas.Font.Color:=dFont.Color;
           Canvas.TextOut(x,y,text);
          end;
        2:begin
           //e
           Canvas.Font.Color:=Col;
           Canvas.TextOut(x+2,y+2,text);
           Canvas.Font.Color:=dFont.Color;
           Canvas.TextOut(x,y,text);
          end;
        3:begin
           //w
           Randomize;
           Canvas.TextOut(x+Random(bFOnt.Size div 3),y,text);
          end;
        4:begin
           //x
           Randomize;
           Canvas.TextOut(x,y+Random(bFOnt.Size div 3),text);
          end;
        5:begin
           //wx
           Randomize;
           i:=Random(bFOnt.Size div 3);
           Randomize;
           i2:=Random(bFOnt.Size div 3);
           Canvas.TextOut(x+i,y+i2,text);
          end;
        6:begin
           //
           Canvas.Font.Color:=Col;
           Canvas.TextOut(x-1,y-1,text);
           Canvas.Font.Color:=dFont.Color;
           Canvas.TextOut(x,y,text);
          end;
   end;

   Canvas.Font.Assign(dFont);

  finally
   dFont.Free;
  end;
end;

procedure StdTextOut(iNo,x,y:Integer;text:String;bFOnt:TFont;Col:TColor;ToBMP:TBitmap);
var cFOnt:TFOnt;
    i,i2 :Integer;
begin

  cFOnt:=TFOnt.Create;
  try
   cFOnt.Assign(bFOnt);
   case iNo of
        0:begin
           SupertextOut(ToBMP,x,y,bFont,Text);
          end;
        1:begin
           //
           cFOnt.Color:=Col;
           SupertextOut(ToBMP,x+1,y+1,cFont,Text);
           SupertextOut(ToBMP,x+1,y,cFont,Text);
           SupertextOut(ToBMP,x+1,y-1,cFont,Text);
           SupertextOut(ToBMP,x,y+1,cFont,Text);
           SupertextOut(ToBMP,x,y-1,cFont,Text);
           SupertextOut(ToBMP,x-1,y+1,cFont,Text);
           SupertextOut(ToBMP,x-1,y,cFont,Text);
           SupertextOut(ToBMP,x-1,y-1,cFont,Text);

           SupertextOut(ToBMP,x,y,bFont,Text);
          end;
        2:begin
           //e
           cFOnt.Color:=Col;
           SupertextOut(ToBMP,x+2,y+2,cFont,Text);
           SupertextOut(ToBMP,x,y,bFont,Text);
          end;
        3:begin
           //w
           Randomize;
           SupertextOut(ToBMP,x+Random(bFOnt.Size div 3),y,cFont,Text);
          end;
        4:begin
           //x
           Randomize;
           SupertextOut(ToBMP,x,y+Random(bFOnt.Size div 3),cFont,Text);
          end;
        5:begin
           //wx
           Randomize;
           i:=Random(bFOnt.Size div 3);
           Randomize;
           i2:=Random(bFOnt.Size div 3);
           SupertextOut(ToBMP,x+i,y+i2,cFont,Text);
          end;
        6:begin
           //
           SupertextOut(ToBMP,x-1,y-1,bFont,Text);
           cFOnt.Color:=Col;
           SupertextOut(ToBMP,x,y,cFont,Text);
          end;
   end;

  finally
   cFOnt.Free;
  end;
end;

/////////////////////////////////////////////////////////////
//
//
//  eLXgC[[`iADVRUNp)
//  `lɃA`GCAXWJB
//
/////////////////////////////////////////////////////////////

{eLXgC[}
procedure SuperTextOut_Layer(ToBMP:TBitmap;X,Y:Integer;bFont:TFont;Msg:String);
var x2,y2,x3:Integer;//[vp
    Pr :Integer;//Zϒl
    BMP      :TBitmap;
    Size     :TSize;
    pABit    :array[0..1] of PByteArray;
    W,H      :Integer;//
    iA,iA2   :DWORD;
    k3,k4:Integer;//ɌvZĂ܂
    r,g,b    :byte;
    li    :LongInt;
    PBit3: PRGBAArray;
    rgba:TRGBA;
begin
   li:=ColorToRGB(bFont.Color);

   b:=(li and $000000FF);
   g:=(li and $0000FF00) shr 8;
   r:=(li and $00FF0000) shr 16;


 //NGCg
 BMP:=TBitmap.Create;
 try

  //ݒ
  BMP.Canvas.Font.Name:=bFOnt.Name;
  BMP.Canvas.Font.Size:=bFOnt.Size*2;
  BMP.Canvas.Font.Style:=bFont.Style;


  //TCY͏قɍ킹
  Size:=BMP.Canvas.TextExtent(Msg);

  //̐ݒ
  W:=(Size.cx div 2);
  H:=(Size.cy div 2);

  BMP.PixelFormat  := pf32Bit;
  //TCYm
  BMP.Width  :=W*2+2;
  BMP.Height :=H*2+2;



  //`
  BMP.Canvas.Brush.Style:=bsClear;
  BMP.Canvas.Font.Color :=clBlack;
  BMP.Canvas.TextOut(0,0,msg);


  k3:=1;




  for y2:=0 to h-1 do begin

      //xC̎擾
      Pbit3:=ToBMP.ScanLine[y2+y];

      //Oɒuč

      //XLC擾OŎs
      pABit[0]:=BMP.ScanLine[k3];
      inc(k3);
      pABit[1]:=BMP.ScanLine[k3];
      inc(k3);


      //ɌvZ
      x3:=x;
      k4:=0;

      for x2:=0 to w-1 do begin

          //qfa̎擾

             //ǂݍ
             Pr:=0;

             inc(pr,PABit[0][k4]);
             inc(pr,PABit[0][k4+4]);
             inc(pr,PABit[1][k4]);
             inc(pr,PABit[1][k4+4]);


             //ϒlo
             //
             rgba:=pBit3[x3];

             if pr<255*4 then begin
                iA:=(pr shr 2);

                rgba.r:=r;
                rgba.g:=g;
                rgba.b:=b;
                rgba.a:=iA;
             end;

             //
             pBit3[x3]:=rgba;


             inc(x3);
             inc(k4,8);
      end;
  end;



  finally
    //
    BMP.Free;
  end;

end;

procedure SuperTextOutFast_Layer(ToBMP:TBitmap;X,Y:Integer;bFont:TFont;Msg:String);
var x2,y2,x3:Integer;//[vp
    Pr :Integer;//Zϒl
    BMP      :TBitmap;
    Size     :TSize;
    pABit    :array[0..1] of PByteArray;
    W,H      :Integer;//
    iA,iA2   :DWORD;
    k3,k4:Integer;//ɌvZĂ܂
    r,g,b    :byte;
    li    :LongInt;
    PBit3: PRGBAArray;
    rgba:TRGBA;
begin
   li:=ColorToRGB(bFont.Color);

   b:=(li and $000000FF);
   g:=(li and $0000FF00) shr 8;
   r:=(li and $00FF0000) shr 16;


 //NGCg
 BMP:=TBitmap.Create;
 try

  //ݒ
  BMP.Canvas.Font.Name:=bFOnt.Name;
  BMP.Canvas.Font.Size:=bFOnt.Size;
  BMP.Canvas.Font.Style:=bFont.Style;


  //TCY͏قɍ킹
  Size:=BMP.Canvas.TextExtent(Msg);

  //̐ݒ
  W:=(Size.cx);
  H:=(Size.cy);

  BMP.PixelFormat  := pf32Bit;
  //TCYm
  BMP.Width  :=W+1;
  BMP.Height :=H+1;



  //`
  BMP.Canvas.Brush.Style:=bsClear;
  BMP.Canvas.Font.Color :=clBlack;
  BMP.Canvas.TextOut(0,0,msg);


  k3:=0;




  for y2:=0 to h-1 do begin

      //xC̎擾
      Pbit3:=ToBMP.ScanLine[y2+y];

      //Oɒuč

      //XLC擾OŎs
      pABit[0]:=BMP.ScanLine[k3];
      inc(k3);


      //ɌvZ
      x3:=x;
      k4:=0;

      for x2:=0 to w-1 do begin

          //qfa̎擾

             //ǂݍ
             Pr:=0;

             inc(pr,PABit[0][k4]);


             //ϒlo
             //
             rgba:=pBit3[x3];

             if pr<255 then begin

                rgba.r:=r;
                rgba.g:=g;
                rgba.b:=b;
                rgba.a:=0;

             end;

             //
             pBit3[x3]:=rgba;


             inc(x3);
             inc(k4,4);
      end;
  end;



  finally
    //
    BMP.Free;
  end;

end;

procedure StdTextOut_Layer(iNo,x,y:Integer;text:String;bFOnt:TFont;Col:TColor;ToBMP:TBitmap);
var cFOnt:TFOnt;
    i,i2 :Integer;
begin

  cFOnt:=TFOnt.Create;
  try
   cFOnt.Assign(bFOnt);
   case iNo of
        0:begin
           SupertextOut_Layer(ToBMP,x,y,bFont,Text);
          end;
        1:begin
           //
           cFOnt.Color:=Col;
           SupertextOut_Layer(ToBMP,x+2,y+2,cFont,Text);
           SupertextOut_Layer(ToBMP,x+2,y+1,cFont,Text);
           SupertextOut_Layer(ToBMP,x+2,y  ,cFont,Text);
           SupertextOut_Layer(ToBMP,x+1,y+2,cFont,Text);
           SupertextOut_Layer(ToBMP,x+1,y  ,cFont,Text);
           SupertextOut_Layer(ToBMP,x  ,y+2,cFont,Text);
           SupertextOut_Layer(ToBMP,x  ,y+1,cFont,Text);
           SupertextOut_Layer(ToBMP,x  ,y  ,cFont,Text);

           SupertextOut_Layer(ToBMP,x+1,y+1,bFont,Text);
          end;
        2:begin
           //e
           cFOnt.Color:=Col;
           SupertextOut_Layer(ToBMP,x+2,y+2,cFont,Text);
           SupertextOut_Layer(ToBMP,x,y,bFont,Text);
          end;
        3:begin
           //w
           Randomize;
           SupertextOut_Layer(ToBMP,x+Random(bFOnt.Size div 3),y,cFont,Text);
          end;
        4:begin
           //x
           Randomize;
           SupertextOut_Layer(ToBMP,x,y+Random(bFOnt.Size div 3),cFont,Text);
          end;
        5:begin
           //wx
           Randomize;
           i:=Random(bFOnt.Size div 3);
           Randomize;
           i2:=Random(bFOnt.Size div 3);
           SupertextOut_Layer(ToBMP,x+i,y+i2,cFont,Text);
          end;
        6:begin
           //
           SupertextOut_Layer(ToBMP,x-1,y-1,bFont,Text);
           cFOnt.Color:=Col;
           SupertextOut_Layer(ToBMP,x,y,cFont,Text);
          end;
   end;

  finally
   cFOnt.Free;
  end;
end;

procedure StdTextOutFast_Layer(iNo,x,y:Integer;text:String;bFOnt:TFont;Col:TColor;ToBMP:TBitmap);
var cFOnt:TFOnt;
    i,i2 :Integer;
begin

  cFOnt:=TFOnt.Create;
  try
   cFOnt.Assign(bFOnt);
   case iNo of
        0:begin
           SupertextOutFast_Layer(ToBMP,x,y,bFont,Text);
          end;
        1:begin
           //
           cFOnt.Color:=Col;
           SupertextOutFast_Layer(ToBMP,x+1,y+1,cFont,Text);
           SupertextOutFast_Layer(ToBMP,x+1,y,cFont,Text);
           SupertextOutFast_Layer(ToBMP,x+1,y-1,cFont,Text);
           SupertextOutFast_Layer(ToBMP,x,y+1,cFont,Text);
           SupertextOutFast_Layer(ToBMP,x,y-1,cFont,Text);
           SupertextOutFast_Layer(ToBMP,x-1,y+1,cFont,Text);
           SupertextOutFast_Layer(ToBMP,x-1,y,cFont,Text);
           SupertextOutFast_Layer(ToBMP,x-1,y-1,cFont,Text);

           SupertextOutFast_Layer(ToBMP,x,y,bFont,Text);
          end;
        2:begin
           //e
           cFOnt.Color:=Col;
           SupertextOutFast_Layer(ToBMP,x+2,y+2,cFont,Text);
           SupertextOutFast_Layer(ToBMP,x,y,bFont,Text);
          end;
        3:begin
           //w
           Randomize;
           SupertextOutFast_Layer(ToBMP,x+Random(bFOnt.Size div 3),y,cFont,Text);
          end;
        4:begin
           //x
           Randomize;
           SupertextOutFast_Layer(ToBMP,x,y+Random(bFOnt.Size div 3),cFont,Text);
          end;
        5:begin
           //wx
           Randomize;
           i:=Random(bFOnt.Size div 3);
           Randomize;
           i2:=Random(bFOnt.Size div 3);
           SupertextOutFast_Layer(ToBMP,x+i,y+i2,cFont,Text);
          end;
        6:begin
           //
           SupertextOutFast_Layer(ToBMP,x-1,y-1,bFont,Text);
           cFOnt.Color:=Col;
           SupertextOutFast_Layer(ToBMP,x,y,cFont,Text);
          end;
   end;

  finally
   cFOnt.Free;
  end;
end;

procedure MakeColorKeyMask32(x,y,w,h:Integer;BMP:TBitmap;Col:TColor);
var
  pBit,pBit2: PByteArray;
  pxlRGB    : LongInt;
  e,ew,k,k2,ix,iy,iw,ih,ox,oy,ow,oh:Integer;
begin


   //

   //ߐF
   pxlRGB:=ColorToRGB(Col);
   //pxlRGB:=Col;
   //TCY̒
   ix:=0;
   iy:=0;
   iw:=w;
   ih:=h;
   ox:=x;
   oy:=y;
   ow:=BMP.Width;
   oh:=BMP.Height;

   If not SetXYWHAuto(ix,iy,iw,ih,ox,oy,ow,oh) then exit;

   k:=ox*4;//o͐ʒu
   k2:=ix*4;//͐ʒu
   ew:=iw;



   for e:=0 to ih-1 do begin
     pBit:= BMP.ScanLine[e+oy];
     asm
       push esi; push edi; push ebx;push edx; // WX^ޔ
       mov esi,pBit;
       add esi,k2;
       mov ebx,pxlRGB;
       and ebx,$00FFFFFF;
       mov ecx,ew;
      @loop_horz:
         mov eax,[esi];
         mov edx,$FF000000;
         and eax,$00FFFFFF;
         cmp eax,ebx;
         je  @put_pixel_end;

         //Rs[B
         mov edx,$00000000;

         @put_pixel_end:

         //At@l݁B
         or  eax,edx;
         mov [esi],eax;
         add esi,4;
         dec ecx;
         jnz @loop_horz;

       pop edx;pop ebx; pop edi; pop esi;    // WX^
     end;
   end;

end;



end.

